#!/usr/bin/env node

//本命令输出自定义窗体模板信息，目前只包括node_modules,后续窗体源码模板生成需要支持
let args = process.argv;
const fs = require('fs');
const path = require('path');
const ioUtils = require('../src/utils/IOUtils');

if (args.length < 3) {
    consoleUtils.out({
        "success":false,
        "type":"IllegalArgumentException",
        title:"传入参数不正确",
        content:"传入参数不正确：请传递构件源码路径信息！"
    });
} else {
    let componentSrcPath = args[2];
    let bins = [],plugins = [];
    let pluginPath = fs.realpathSync('.');
    let nodeModules = path.resolve(pluginPath,"node_modules");
    let v3webpackPath = path.resolve(pluginPath,"node_modules","v3webpack-cli");
    let v3webpackPackageJson = require(path.resolve(v3webpackPath,"package.json"));
    let iter = (pluginName)=>{
        plugins.push(pluginName);
        try{
            let packageJson = require(path.resolve(nodeModules,pluginName,"package.json"));
            let bin = packageJson.bin;
            if(bin){
                Object.keys(bin).forEach(binName => {
                    bins.push(binName);
                });
            }
            let dependencies = packageJson.dependencies;
            if(dependencies){
                Object.keys(dependencies).forEach(depName=>{
                    iter(depName);
                });
            }
        }catch(e){
            console.log('nodejs插件【'+pluginName+'】读取package.json出错，请检查！');
        }
    };
    iter("v3webpack-cli");
    if(bins.length>0){
        ioUtils.copyDirWithFilter(path.resolve(nodeModules,'.bin'),path.resolve(componentSrcPath,"node_modules",".bin"),(srcPath,distPath)=>{
            let fileName = path.basename(srcPath);
            let index = fileName.lastIndexOf('.');
            let fileNameWithoutExt = index==-1 ? fileName:fileName.substring(0,index);
            index == bins.indexOf(fileNameWithoutExt);
            return index!=-1;
        });
    }
    if(plugins.length>0){
        plugins.forEach(plugin=>{
            ioUtils.copyDirWithFilter(path.resolve(nodeModules,plugin),path.resolve(componentSrcPath,"node_modules",plugin));
        });
    }
    consoleUtils.out({
        "success":true,
        "type":"TemplateSynced",
        title:"构件模板同步完成",
        content:"构件模板同步完成！"
    });
}