#!/usr/bin/env node

var webpack = require("webpack");
var pathUtils = require("../src/utils/PathUtils");
var fs =require('fs');
var userWebpackConfigPath = pathUtils.getPluginPath() + "/build/webpack.config.js";
var configs;
if(fs.existsSync(userWebpackConfigPath) && fs.statSync(userWebpackConfigPath).isFile()){
  configs = require(userWebpackConfigPath);
}else{
  configs = require("../build/webpack.prod.config.js");  
}


webpack(configs,function(err,stats){
  if (err) {
    console.error(err.stack || err);
    if (err.details) {
      console.error(err.details);
    }
    return;
  }

  const info = stats.toJson();

  if (stats.hasErrors()) {
    var errors = info.errors;
    for(var i=0,l=errors.length;i<l;i++){
      console.error(errors[i]);
      //console.error('\033[31m'+errors[i]+'\033[39m');
    }
  }

  if (stats.hasWarnings()) {
    console.warn(info.warnings);
  }
});
