var componentUtils = require('../src/utils/componentUtils');
var components = componentUtils.analyzeComponents();

var rules = require("../src/package/WebpackDefaultLoaders");
rules = rules.concat((require("../src/package/WebpackFileLoader").getLoaders(components)));

var Generator = require("../src/package/WindowPreviewIndexGenerator");
var generator = new Generator(components);
generator.generate();

var merge = require("webpack-merge");
var baseConfig = require("../src/package/WebpackBaseConfig");

var defaultAlias = require("../src/package/WebpackDefaultAlias");
var componentAlias = require("../src/package/WebpackComponentAlias").getComponentAlias(components);
var alias = merge(defaultAlias,componentAlias);

var defaultPlugins = require("../src/package/WebpackDefaultPlugin").getPlugins(components);
var htmlPlugins = require("../src/package/WebpackHtmlPlugin").getPlugins(components);
var extractTextPlugins = require("../src/package/WebpackExtractTextPlugin").getPlugins(components);
var plugins = defaultPlugins.concat(extractTextPlugins).concat(htmlPlugins);

var defaultEntry = require("../src/package/WebpackDefaultEntry");
var componentEntry = require("../src/package/WebpackComponentEntry").getEntries(components);
var entry = merge(defaultEntry,componentEntry);

var webpackConfigs = {
  module:{
    rules:rules
  },
  entry: entry,
  resolve : {
    alias : alias
  },
  node: {
    fs: 'empty'
  },
  plugins : plugins
};

var configs = merge(baseConfig,webpackConfigs);

module.exports = {
  configs : configs,
  components : components
};
