var pathUtils = require("../utils/PathUtils");
var previewUtils = require('../utils/PreviewUtils');

module.exports = {
  getEntries : function(components){
    var entry = {};
    var isGeneratePreviewFile = previewUtils.isGeneratePreviewFile();
    for(var i=0,l=components.length;i<l;i++){
      var component = components[i];
      var componentCode = component.getCode();
      var windows = component.getWindows();
      if(windows&&windows.length>0){
        for(var j=0,len=windows.length;j<len;j++){
          var win = windows[j];
          var windowCode = win.getCode();
          entry[pathUtils.toWindowDistPath(componentCode,windowCode)] = win.getIndexPath();
          var widgets = win.widgets;
          if(isGeneratePreviewFile && widgets && widgets.length > 0){
            for(var m =0,n = widgets.length ;m<n; m++){
              var widget = widgets[m];
              entry[pathUtils.toWindowPreviewDistPath(componentCode,windowCode,widget.getCode())] = widget.getPreviewIndexPath();
            }
          }
        }
      }
    }
    return entry;
  }
};
