var webpack = require('webpack');
var path = require('path');
var pathUtils = require('../utils/PathUtils');
var CopyWebpackPlugin = require('copy-webpack-plugin');
var HtmlWebpackPlugin = require('html-webpack-plugin');
var ExtractTextPlugin = require('extract-text-webpack-plugin');
var previewUtils = require('../utils/PreviewUtils');

module.exports = {
  getPlugins : function(components){
    var componentCode = components[0].getCode();
    
    var result =[
      new webpack.HashedModuleIdsPlugin(),
      new webpack.optimize.CommonsChunkPlugin({
        name: "vendor",
        filename: pathUtils.getComponentResource(componentCode,"vendor.lib.js"),
      })
    ];
    if(previewUtils.isGeneratePreviewFile()){
      result.push(new HtmlWebpackPlugin({
        filename: 'index.html',
        template: 'node_modules/v3webpack-cli/src/vendor/vplatform/index.html',
        chunks : ["vendor","index"]
      }));
      result.push(new CopyWebpackPlugin([{
        from: path.join(__dirname,'../../','/src/vendor/vplatform/assets'),
        to  : path.join(pathUtils.getPluginPath(),'dist/vendor/vplatform/assets')
      }]));
    }
    return result;
  }
};
