var HtmlWebpackPlugin = require('html-webpack-plugin');
var pathUtils = require('../utils/PathUtils');
var previewUtils = require('../utils/PreviewUtils');

module.exports = {

  getPlugins : function(components){
    var plugins = [];
    if(previewUtils.isGeneratePreviewFile()){
      for(var i=0,l=components.length;i<l;i++){
        var component = components[i];
        var componentCode = component.getCode();
        var wins = component.getWindows();
        if(wins){
          for(var j=0,len=wins.length;j<len;j++){
            var win = wins[j];
            var windowCode = win.getCode();
            var distPath = pathUtils.toWindowDistPath(componentCode,windowCode);
            var widgets = win.getWidgets();
            if(widgets && widgets.length > 0){
              for(var m = 0,n = widgets.length;m<n;m++){
                var widgetCode = widgets[m].getCode();
                plugins.push(new HtmlWebpackPlugin({
                  filename: pathUtils.toWindowPreviewHtmlDistPath(componentCode,windowCode,widgetCode),
                  template: 'node_modules/v3webpack-cli/src/vendor/vplatform/windowPreview.html',
                  chunks : ["vendor",pathUtils.toWindowDistPath(componentCode,windowCode),pathUtils.toWindowPreviewDistPath(componentCode,windowCode,widgetCode)]
                }));
              }
            }
            // plugins.push(new HtmlWebpackPlugin({
            //   filename: pathUtils.toWindowPreviewHtmlDistPath(componentCode,windowCode),
            //   template: 'node_modules/v3webpack-cli/src/vendor/vplatform/windowPreview.html',
            //   chunks : ["vendor",pathUtils.toWindowDistPath(componentCode,windowCode),pathUtils.toWindowPreviewDistPath(componentCode,windowCode)]
            // }));
          }
        }
      }
    }
    return plugins;
  }

};
