var pathUtils = require("../utils/PathUtils");
var ioUtils = require("../utils/IOUtils");
var path = require("path");
var windowPreviewIndexTpl = require("../vendor/vplatform/windowPreviewIndexTpl");
var divPreviewIndexTpl = require("../vendor/vplatform/divPreviewIndexTpl");

var Generator = function(components){
  this.components = components;
};

Generator.prototype = {
  generate : function(){
    var pluginPath = pathUtils.getPluginPath();
    for(var i=0,l=this.components.length;i<l;i++){
      var cmp = this.components[i];
      var componentCode = cmp.getCode();
      var wins = cmp.getWindows();
      if(wins){
        for(var j=0,len=wins.length;j<len;j++){
          var win = wins[j];
          var windowCode = win.getCode();
          // var script = windowPreviewIndexTpl({
          //   componentCode : componentCode,
          //   windowCode : windowCode,
          //   widgets : win.getWidgets()
          // });
          var widgets = win.getWidgets();
          if(widgets){
            for(var m = 0,n = widgets.length;m<n;m++){
              var script = divPreviewIndexTpl({
                componentCode : componentCode,
                windowCode : windowCode,
                widget : widgets[m]
              });
              var widgetCode = widgets[m].getCode();
              var relativePath = pathUtils.getWidgetPreviewIndexPath(componentCode,windowCode,widgetCode);
              ioUtils.writeContent(path.join(pluginPath,relativePath),script);
            }
          }
        }
      }
    }
  }
};

module.exports = Generator;
