var path  = require("path");
var fs = require("fs");

module.exports = {
  /**
   * 获取父目录路径
   */
  getParentPath: function(filePath) {
    return path.resolve(filePath,"..");
  },
  /**
   * 创建父目录
   */
  makeDir: function(filePath) {
    var iter = function(parent) {
      if (!fs.existsSync(parent)) {
        var f = this.getParentPath(parent);
        iter.call(this,f);
        fs.mkdirSync(parent);
      }
    };
    var parent = this.getParentPath(filePath);
    iter.call(this,parent);
    if (!fs.existsSync(filePath)) {
      fs.mkdirSync(filePath);
    }
  },
  /**
   * 获取指定目录下的全部文件
   */
  listFiles : function(path, filePaths){
    var files = typeof(filePaths) == "object" ? filePaths : [];
    if(fs.statSync(path).isFile()){
      // var arr = path.split("/");
      // files.push(arr[arr.length - 1]);
      files.push(path);
    }else if(fs.statSync(path).isDirectory()){
      var paths = fs.readdirSync(path);
      for(var i  = 0,len = paths.length;i<len;i++){
        var _files = this.listFiles(path + "\\" + paths[i], files);
        Object.assign(files, _files);
      }
    }
    return files;
  }
};
