var fs = require('fs');
var pathUtil = require('path');
var fileUtils = require('./FileUtils');

module.exports = {
  /**
   * 将内容写入指定路径
   */
  writeContent: function(absPath, content) {
    fileUtils.makeDir(fileUtils.getParentPath(absPath));
    fs.writeFileSync(absPath, content);
  },
  /**
   * 异步将内容写入指定路径
   */
  writeContentAsync : function(absPath,content,callback){
    fileUtils.makeDir(fileUtils.getParentPath(absPath));
    fs.writeFile(absPath,content,callback);
  },
  write : function(absPath, content){
    var _this = this;
    return new Promise(function(resolve,reject){
      try{
        _this.writeContent(absPath, content);
        resolve();
      }catch(e){
        reject(e);
      }
    });
  }

};
